Bone Collector II

Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4198    Accepted Submission(s): 2184


Problem Description
The title of this problem is familiar,isn't it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven't seen it before,it doesn't matter,I will give you a link:

Here is the link: http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.

If the total number of different values is less than K,just ouput 0.
 

Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
 

Output
One integer per line representing the K-th maximum of the total value (this number will be less than 2 31).
 

Sample Input
3 5 10 2 1 2 3 4 5 5 4 3 2 1 5 10 12 1 2 3 4 5 5 4 3 2 1 5 10 16 1 2 3 4 5 5 4 3 2 1
 

Sample Output
12 2 0
 

Author
teddy
 

Source


思路:
一道典型的01背包第k优解问题,就是在01背包装最大价值的基础上,问你装的第k大价值是多少。在01背包中,dp[j]=max{dp[j-v[i]]+w[i],dp[j-1]},所以我们只需要把每种状态的这两个值分别记下来,然后对于每个dp[j]的所有前k大解的可能取值进行排序,从中选取第k大的值即可。套用模板。


代码:
[cpp]  view plain  copy
  1. #include<cstdio>  
  2. #include<cstdlib>  
  3. #include<cstring>  
  4. #include<iostream>  
  5. using namespace std;  
  6.   
  7. int v[1001];  
  8. int w[1001];  
  9. int dp[1001][1001];  
  10. int a[1000],b[1000];   
  11. int d;    
  12.   
  13. int main()  
  14. {  
  15.     //freopen("in.txt","r",stdin);  
  16.     int T;  
  17.     scanf("%d",&T);  
  18.     while(T--)  
  19.     {  
  20.         memset(dp,0,sizeof(dp));  
  21.                 memset(a,0,sizeof(a));  
  22.                 memset(b,0,sizeof(b));  
  23.         int n,V,k;  
  24.         scanf("%d%d%d",&n,&V,&k);  
  25.         for(int i=1;i<=n;i++)  
  26.         {  
  27.             scanf("%d",&w[i]);  
  28.         }  
  29.         for(int i=1;i<=n;i++)  
  30.         {  
  31.             scanf("%d",&v[i]);  
  32.         }  
  33.         for(int i =1;i<=n;i++)    
  34.         {    
  35.             for(int j = V;j>=v[i];j--)    
  36.             {    
  37.                 for(d = 1;d<=k;d++)    
  38.                 {    
  39.                     a[d] = dp[j-v[i]][d] +w[i];    
  40.                     b[d] = dp[j][d];    
  41.                 }    
  42.                 int x =1;  
  43.                 int y = 1;  
  44.                 int z = 1;    
  45.                 a[d] = b[d] = -1;    
  46.                 while(z<=k && (x<=k || y<=k))    
  47.                 {    
  48.                     if(a[x]>b[y])    
  49.                     dp[j][z] = a[x++];    
  50.                     else    
  51.                     dp[j][z] = b[y++];    
  52.                     if(z==1||(dp[j][z]!=dp[j][z-1]))    
  53.                     z++;    
  54.                 }    
  55.             }    
  56.         }    
  57.         printf("%d\n",dp[V][k]);  
  58.     }  
  59.     return 0;  
  60. }